//-------------------------------------------------------------------------------------------------------------------------------
{vyhazuje okno s chybou s moznosti sestrelit PocketDrake}
procedure ShowErrorMessage(txt: String);
begin
  if (MessBox(txt + CRLF + CRLF + 'Pokraovat v provdn makra?','GeoGet',4) = 7) then GeoAbort;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Hleda soubor v dadanem adresari (vcetne podslozek). vraci celou cestu k souboru}
function SearchFile(StartDir,Filename: String): String;
var
   Files,Queue : TStringList;
   n : Integer;
   q : String;
begin
  Result := 'Soubor nenalezen!';
  if not RegexFind('\$',StartDir) then StartDir := StartDir + '\';
  if DirectoryExists(StartDir) then
  begin
    Files := TStringList.Create;
    Queue := TStringList.Create;
    try
      Queue.Add(StartDir);
      while (Queue.Count > 0) do
      begin
        q := Queue[0];
        FileList(q,Files); Queue.Delete(0);
        for n := 0 to Files.Count-1 do
        begin
          if RegexFind('\\$',Files[n])
            then Queue.Add(Files[n])
            else
            begin
              if ReplaceString(Files[n],q,'') = Filename then
              begin
                Result := Files[n];
                Break;
              end;
            end;
        end;
        if Result <> ('Soubor nenalezen!') then Break;
      end;
    finally
      Queue.Free;
      Files.Free;
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{funkce pro ziskani hodnot ze staryho konfiguraku xxxxxxxx.config.pas (neco jako cteni z *.ini)}
function GetVariableValue(FilePath,Variable: String): String;
var
  ValuePos  :Integer;
  Value     :String;
begin
  if RegexFind('\.config.pas$',FilePath) then
  begin
    FilePath := Trim(FileToString(FilePath));
    {pozice hodnoty (k pozici promenne pricteme jeji delku a 4 znaky)}
    ValuePos := Pos(Variable,FilePath) + Length(Variable) + 4;
    {od zacatku hodnoty si vemem treba 20 znaku}
    Value := Copy(FilePath,ValuePos,20);
    {a ty od prvni uvozovky dal odkrojime}
    Value := Copy(FilePath,ValuePos,Pos('''',Value) - 1);
    Result := Value;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{vytvoreni gjtemp.ini}
procedure MakeGeojarryIni;
var
  GjIni :String;
begin
  try
    GjIni := '[geojarry]' + CRLF;
    GjIni := GjIni + 'username='   + GjUsername + CRLF;
    GjIni := GjIni + 'password='   + GjPassword + CRLF;
    GjIni := GjIni + 'proxyip='    + GEOGET_PROXYHOST + CRLF;
    GjIni := GjIni + 'proxyport='  + GEOGET_PROXYPORT + CRLF;
    GjIni := GjIni + 'proxyuser='  + GEOGET_PROXYUSER + CRLF;
    GjIni := GjIni + 'proxypass='  + GEOGET_PROXYPASS + CRLF;
    GjIni := GjIni + 'sessionfile=gjsession.txt' + CRLF;
    GjIni := GjIni + 'datadir=' + MakroPath + 'xTemp' + CRLF;
  finally
    StringTofile(GjIni, MakroPath + 'xTemp\gjtemp.ini');
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{vyhodi okno s popisem chyby geojarryho}
procedure ShowGeojarryError(id: Integer);
begin
  case id of
    3: ShowErrorMessage('GeoJarry chyba: Soubor nenalezen!');
    4: ShowErrorMessage('GeoJarry chyba: Staen neplatn soubor!');
    253: ShowErrorMessage('GeoJarry chyba: Nepodailo se pihlsit na geocaching.com!');
    254: ShowErrorMessage('GeoJarry chyba: Problm v HTTP komunikaci!');
    255: ShowErrorMessage('GeoJarry: Stornovno uivatelem!');
    else ShowErrorMessage('GeoJarry chyba!')
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
procedure UploadOnGC;
var
  script : String;
  err    : Integer;
begin
  script := '"' + GeojarryExe + '" "' + MakroPath + 'xTemp\gjtemp.ini' + '" setform "' + MakroPath + 'FieldNotes_Upload.ini"';
  err := RunExec(script);
  case err of
    0: begin
      RunShell('http://www.geocaching.com/my/fieldnotes.aspx');
    end;
    else ShowGeojarryError(err);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
// testuje zda neni v PDA spusten PocketDrake
function PD_is_Run : boolean;
var
  script : String;
  cond   : boolean;
begin
  if not GGForm_cb_Run_PD_NoTest.Checked then begin
    GeoBusyKind('Testuji zda nen v PDA sputn PocketDrake'); ; GeoBusyValue('');
    script := '"' + MakroPath + 'rapiproc.exe" > "' + MakroPath + 'xTemp\processes.txt"'
    StringToFile(AnsiToOem(script), MakroPath + 'xTemp\processes.bat');
    repeat
      RunExec('"' + MakroPath + 'xTemp\processes.bat' + '"');
      cond := RegexFind('(PocketDrake|pocketdrake)|Pocketdrake', FileToString(MakroPath + 'xTemp\processes.txt'));
      result := cond;
      if cond then
        if (MessBox('PocketDrake je spusten!'+CRLF+'Ukonete ho a pokraujte stiskem tlatka' + CRLF + CRLF + 'Znovu otestovat?','GeoGet',4) = 7) then
          cond := False;
    until not cond;
    GeoBusyKind(''); GeoBusyValue('');
  end
  else result := False;
end;